function doUpdate(dt)
	if timer < 0.4 then 
		timer = timer + dt 
	end
	if not newGame then
		player.timer = player.timer + dt
		shipTimer = shipTimer + dt
		if shipTimer >= 0.5 then
			shipTimer = 0
		end
	end
	for i,v in ipairs(msgs) do
		v.timer = v.timer + dt
		if v.timer > 3 then
			table.remove(msgs, i)
		end
		for j,k in ipairs(msgs) do
			if i ~= j and TB.rectColl(v.x, v.y - (v.timer * 50), font1:getWidth(v.msg), 10, k.x, k.y - (k.timer * 50), font1:getWidth(k.msg), 10) then
				k.y = k.y - 6
				v.y = v.y + 6
			end
		end
	end
	
	if loading > 0 then
		loading = loading + 1
	end
	
	if not menu then
		for i,v in ipairs(planets) do
			if func.checkDistColl(v, player) then
				if func.checkDistColl(v, {x = love.mouse.getX(), y = love.mouse.getY(), size = 1}) and love.mouse.isDown("r") and not openWindow and timer > 0.4 then
					timer = 0
					openWindow = true
					trade = true
					pid = i
					TB.destroyAll()
					for j,k in ipairs(planets[pid]["inventory"]) do
						
						tbox.x = (love.window.getWidth()/2) + 142
						tbox.y = (love.window.getHeight()/2) - 254 + (j * 23)
						
						tbox.text = 1
						
						tbox.name = k.name
		
						TB.create(
							tbox.x, 
							tbox.y, 
							tbox.width, 
							tbox.height, 
							tbox.border, 
							tbox.text, 
							tbox.font, 
							tbox.textOffsetX, 
							tbox.textOffsetY, 
							tbox.borderColor, 
							tbox.backgroundColor,
							tbox.backgroundSelectedColor,
							tbox.borderSelectedColor,
							tbox.textColor,
							tbox.textSelectedColor,
							tbox.name,
							tbox.drawBoxes,
							tbox.clearTextOnSelect,
							tbox.centerText,
							tbox.drawBackground,
							tbox.selectable,
							tbox.button1,
							tbox.button2,
							tbox.button3
						)
					end
				
				end
			end
		end
		if openWindow then
			if love.mouse.isDown("r") and timer > 0.4 then
				timer = 0
				if trade then
					trade = false
					produce = true
					TB.destroyAll()
					for j,k in ipairs(planets[pid]["production"]) do
						
						tbox.x = (love.window.getWidth()/2) + 187
						tbox.y = (love.window.getHeight()/2) - 254 + (j * 23)
						
						tbox.text = 1
						
						tbox.name = k.name
		
						TB.create(
							tbox.x, 
							tbox.y, 
							50, 
							tbox.height, 
							tbox.border, 
							tbox.text, 
							tbox.font, 
							tbox.textOffsetX, 
							tbox.textOffsetY, 
							tbox.borderColor, 
							tbox.backgroundColor,
							tbox.backgroundSelectedColor,
							tbox.borderSelectedColor,
							tbox.textColor,
							tbox.textSelectedColor,
							tbox.name,
							tbox.drawBoxes,
							tbox.clearTextOnSelect,
							tbox.centerText,
							tbox.drawBackground,
							tbox.selectable,
							{"Get", func.getproduction},
							{"Get All", func.getallproduction},
							{"Upgrade", func.buyproduction}
							
						)
						
					end
				elseif produce then
					produce = false
					upgrade = true
					TB.destroyAll()
					for j,k in ipairs(planets[pid]["upgrades"]) do
						
						tbox.x = (love.window.getWidth()/2) + 340
						tbox.y = (love.window.getHeight()/2) - 254 + (j * 23)
						
						tbox.text = player.inventoryMax - player.inventory
						
						tbox.name = k.name
		
						TB.create(
							tbox.x, 
							tbox.y, 
							0, 
							tbox.height, 
							tbox.border, 
							tbox.text, 
							tbox.font, 
							tbox.textOffsetX, 
							tbox.textOffsetY, 
							tbox.borderColor, 
							tbox.backgroundColor,
							tbox.backgroundSelectedColor,
							tbox.borderSelectedColor,
							tbox.textColor,
							tbox.textSelectedColor,
							tbox.name,
							tbox.drawBoxes,
							tbox.clearTextOnSelect,
							tbox.centerText,
							tbox.drawBackground,
							tbox.selectable,
							{"Buy", func.buyupgrade}
						)
					end
				elseif upgrade then
					openWindow = false
					upgrade = false
					TB.destroyAll()
				end
			end
		end
	end

	if not paused and not gameOver and not map and not openWindow and not inven then
		bgTimer = bgTimer + dt
		if bgTimer > 4 then
			bgTimer = 0
			if bgSwitch then
				rng = love.math.random(6)
				if rng == 1 and backgroundColor[1] < 60 then
					backgroundColor[1] = backgroundColor[1] + 1
				elseif rng == 2 and backgroundColor[2] < 60 then
					backgroundColor[2] = backgroundColor[2] + 1
				elseif rng == 3 and backgroundColor[3] < 60 then
					backgroundColor[3] = backgroundColor[3] + 1
				end
			elseif not bgSwitch then
				if rng == 1 and backgroundColor[1] > 20 then
					backgroundColor[1] = backgroundColor[1] - 1
				elseif rng == 2 and backgroundColor[2] > 20 then
					backgroundColor[2] = backgroundColor[2] - 1
				elseif rng == 3 and backgroundColor[3] > 20 then
					backgroundColor[3] = backgroundColor[3] - 1
				end
			end
		end
		
		player.productionTimer = player.productionTimer + dt
		if player.productionTimer > 900 then
			player.productionTimer = 0
			for i,v in ipairs(planets) do
				for j,k in ipairs(planets[i]["production"]) do
					if k.level > 0 then
						k.amount = k.amount + love.math.random(k.production/1.3, k.production)
					end
				end
			end
		end
		
		sec = sec + dt
		if sec >= 60 then
			if bgSwitch then 
				bgSwitch = false
			else
				bgSwitch = true
			end
			sec = 0
			min = min + 1
			for i,v in ipairs(planets) do
				for j,k in ipairs(planets[i]["inventory"]) do
					for u,t in ipairs(resources) do
						if t.name == k.name and k.price + k.rarity > t.value/1.2 then
							k.price = k.price + love.math.random(-k.rarity, k.rarity)
						elseif t.name == k.name and k.price + k.rarity <= t.value/1.2 then
							k.price = k.price + love.math.random(k.rarity)
						elseif t.name == k.name and k.price + k.rarity > t.value*1.4 then
							k.price = k.price + love.math.random(-k.rarity, 0)
						end
					end
					
					if k.produces then
						k.amount = k.amount + love.math.random(-100/k.rarity,100/k.rarity)
						if k.amount < 0 then
							k.amount = 0
						end
					else
						k.amount = k.amount + love.math.random(-100/k.rarity,0)
						if k.amount < 0 then
							k.amount = 0
						end
					end
				end
			end
			
			for i = 1,love.math.random(1,5 + player.level) do
				func.createShip()
			end
			
			for i,v in ipairs(objects) do
				if v.type == 6 and v.x < -10 and v.x > love.window.getWidth() + 10 and v.y < -10 and v.y > love.window.getHeight() + 10 then
					table.remove(objects, i)
				end
			end
			
			if love.math.random(2) == 1 then
				tempX = love.math.random(love.window.getWidth() + 8, love.window.getWidth() + 4000)
				tempY = love.math.random(love.window.getHeight() + 8, love.window.getHeight() + 4000)
			else
				tempX = love.math.random(-4000, -8)
				tempY = love.math.random(-4000, -8)
			end
			
			if love.math.random(20) == 1 then
				tempLVL = player.level + love.math.random(5)
			else
				tempLVL = player.level + love.math.random(3)
			end
			
			table.insert(objects, {x = tempX, y = tempY, type = 6, size = 8, level = tempLVL})
			
			if min == 60 then
				min = 0
				hour = hour + 1
			end
		end
		
		if hour > 1 then timestr = " - TIME: " .. hour .. " HRS " .. min .. " MINS " .. math.floor(sec) .. " SECS" end
		if hour > 1 and min == 1 then timestr = " - TIME: " .. hour .. " HRS " .. min .. " MIN " .. math.floor(sec) .. " SECS" end
		if hour > 1 and math.floor(sec) == 1 then timestr = " - TIME: " .. hour .. " HRS " .. min .. " MINS " .. math.floor(sec) .. " SEC" end
		if hour > 1 and min == 1 and math.floor(sec) == 1 then timestr = " - TIME: " .. hour .. " HRS " .. min .. " MIN " .. math.floor(sec) .. " SEC" end
		if hour == 1 then timestr = " - TIME: " .. hour .. " HR " .. min .. " MINS " .. math.floor(sec) .. " SECS" end
		if hour == 1 and min == 1 then timestr = " - TIME: " .. hour .. " HR " .. min .. " MIN " .. math.floor(sec) .. " SECS" end
		if hour == 1 and math.floor(sec) == 1 then timestr = " - TIME: " .. hour .. " HOUR " .. min .. " MINUTES " .. math.floor(sec) .. " SEC" end
		if hour == 0 and min > 1 then timestr = " - TIME: " .. min .. " MINS " .. math.floor(sec) .. " SECS" end
		if hour == 0 and min == 1 then timestr = " - TIME: " .. min .. " MIN " .. math.floor(sec) .. " SECS" end
		if hour == 0 and min == 1 and math.floor(sec) == 1 then timestr = " - TIME: " .. min .. " MIN " .. math.floor(sec) .. " SEC" end
		if hour == 0 and min > 1 and math.floor(sec) == 1 then timestr = " - TIME: " .. min .. " MINS " .. math.floor(sec) .. " SEC" end
		if min == 0 and hour == 0 then timestr =" - TIME: " .. math.floor(sec) .. " SECS" end
		if min == 0 and hour == 0 and math.floor(sec) == 1 then timestr =" - TIME: " .. math.floor(sec) .. " SEC" end
		
		planetsRotTimer = planetsRotTimer + dt
		
		if planetsRotTimer > 0.045 then
			planetsRotTimer = 0
			planetsRotFrame = planetsRotFrame + 1
			if planetsRotFrame > 99 then
				planetsRotFrame = 0
			end
		end
		
		planetsRotTimer2 = planetsRotTimer2 + dt
		
		if planetsRotTimer2 > 0.045 then
			planetsRotTimer2 = 0
			planetsRotFrame2 = planetsRotFrame2 + 1
			if planetsRotFrame2 > 199 then
				planetsRotFrame2 = 0
			end
		end
	
		if player.afterBurnerBoost <= 0 then
			player.afterBurnerTimer = player.afterBurnerTimer + dt
		end
		
		if player.afterBurnerTimer > player.afterBurnerTimerSet and player.afterBurner < player.afterBurnerMax then
			player.afterBurnerTimer = 0
			player.afterBurner = player.afterBurner + 1
		end
		
		if love.keyboard.isDown(" ") and player.afterBurner > 1 then
			if player.afterBurnerBoost < player.afterBurnerMax * 15 then
				player.afterBurnerBoost = player.afterBurnerBoost + (player.afterBurnerMax * dt)
			end
			player.afterBurner = player.afterBurner - (1 * dt)
			player.speed = player.speedMax + player.afterBurnerBoost
			if player.afterBurner <= 0 then
				player.afterBurner = 0
			end
		else
			if player.afterBurnerBoost > 0 then
				player.speed = player.speed - player.afterBurnerBoost
				if player.afterBurnerBoost > 0 then
					player.afterBurnerBoost = player.afterBurnerBoost - ((player.afterBurnerMax * 20) * dt)
				end
				if player.afterBurnerBoost < 0 then
					player.afterBurnerBoost = 0
				end
				if player.speed <= player.speedMax then
					player.speed = player.speedMax
				end
			end
		end
		
		for i,v in ipairs(bullets) do
			v.x = v.x + (v.dx * dt)
			if v.x > love.window.getWidth() + 100 then
				table.remove(bullets, i)
			end
			if v.x < -100 then
				table.remove(bullets, i)
			end
			
			v.y = v.y + (v.dy * dt)
			if v.y > love.window.getHeight() + 100 then
				table.remove(bullets, i)
			end
			if v.y < -100 then
				table.remove(bullets, i)
			end
			
			for n,m in ipairs(bullets) do
				if not m.id == 1 and func.checkDistColl(v,m) and n ~= i then
					table.remove(bullets, i)
					table.remove(bullets, n)
					local rng = love.math.random(1,3)
					for i = 1, rng do
						table.insert(background, {x = m.x + love.math.random(-10,10), y = m.y + love.math.random(-10,10), layer = 1, extra = true, color = {love.math.random(150,255), love.math.random(150,255), 0}})
					end
				end
			end
			
			if v.id == 1 then
				for j,k in ipairs(objects) do
					if func.checkDistColl(v,k) and k.type ~= 3 and k.type ~= 4 and k.type ~= 5 then
						table.remove(bullets, i)
						
						local damg = math.floor(love.math.random(player.attack / 1.5, player.attack)) / 10
						if damg < 0.1 then
							damg = 0.1
						end
						k.health = k.health - damg
						table.insert(msgs, {msg = "-" .. damg * 10, x = k.x - (font1:getWidth( "-" .. damg * 10 )/2), y = k.y - 20, timer = 0})
					
						if k.type == 1 then
							local rng2 = love.math.random(player.attack,player.attack*2)
							for i = 1, rng2 do
								local rngB = love.math.random(120)
								table.insert(background, {x = v.x + love.math.random(-10,10), y = v.y + love.math.random(-10,10), layer = 1, extra = true, color = {80 + rngB, 80 + rngB, 80 + rngB}})
							end
							k.size = k.health
							local rng2 = love.math.random(1600 / (player.attack * 10))
							if rng2 == 1 then
								table.insert(objects, {x = k.x, y = k.y, type = 4, size = 8})
							end
							
						elseif k.type == 2 then
							local rng = love.math.random(2,5)
							for i = 1, rng do
								table.insert(background, {x = v.x + love.math.random(-10,10), y = v.y + love.math.random(-10,10), layer = 1, extra = true, color = {k.color[1] + love.math.random(-20,20), k.color[2] + love.math.random(-20,20), k.color[3] + love.math.random(-20,20)}})
							end
							if k.status ~= 3 then
								k.status = 2
								if k.faction > 0 then
									for o,p in ipairs(objects) do
										if p.type == 2 and p.faction == k.faction and p.faction > 0 then
											p.status = 2
										end
									end
								end
							end
						end
					
						if k.health <= 3 then
							if k.type == 1 then
								func.createAsteroid()
							elseif k.type == 2 then
								local rng = love.math.random(10,30)
								for i = 1, rng do
									table.insert(background, {x = v.x + love.math.random(-10,10), y = v.y + love.math.random(-10,10), layer = 1, extra = true, color = k.color})
								end
								player.xp = player.xp + math.floor(k.level * 150)
								if player.xp >= player.xpNext then
									player.xp = player.xp - player.xpNext
									player.xpNext = math.floor(player.xpNext * 1.5)
									player.level = player.level + 1
								end
								table.insert(msgs, {msg = math.floor(k.level * 150) .. " XP", x = k.x - (font1:getWidth( math.floor(k.level * 150) .. " XP" )/2), y = k.y - 20, timer = 0})
								table.insert(objects, {x = k.x, y = k.y, type = 3, size = 8, level = k.level})
							end
							table.remove(objects, j)
						end
					end
				end
			elseif v.id == 2 then
				if func.checkDistColl(v,player) then
					player.health = player.health - v.dmg
					local rng = love.math.random(4,10)
					for i = 1, rng do
						table.insert(background, {x = v.x + love.math.random(-10,10), y = v.y + love.math.random(-10,10), layer = 1, extra = true, color = {love.math.random(150,200), love.math.random(170,255), 0}})
						extrabg = extraBg + 1
					end
					if player.health <= 0 then
						player.health = 0
						gameOver = true
					end
					table.remove(bullets, i)
				end
			end
		end
		
		for i,v in ipairs(objects) do
			
			if v.type == 3 and func.checkDistColl(player,v) then
				if player.inventoryMax > player.inventory then
					tempAmount = love.math.random(math.floor(1 + v.level/2))
					if tempAmount + player.inventory > player.inventoryMax then
						tempAmount = player.inventoryMax - player.inventory
					end
					player.inventory = player.inventory + tempAmount
					if player.level < v.level then
						p = 6 - (v.level - player.level)
					else
						p = 7
					end
					foundRes = false
					while p <= #resources do
						if player.level < v.level and love.math.random(resources[p]["rarity"]) == 1 + math.floor((v.level - player.level)/2) then
							tempName = resources[p]["name"]
							p = #resources + 1
							foundRes = true
						elseif player.level >= v.level and love.math.random(resources[p]["rarity"]) == 1  then
							tempName = resources[p]["name"]
							p = #resources + 1
							foundRes = true
						end
						if p == #resources and not foundRes then
							if player.level < v.level then
								p = 5 - (v.level - player.level)
							else
								p = 6
							end
						end
						p = p + 1
					end
					table.insert(msgs, {msg = tempAmount .. " " .. tempName, x = v.x - (font1:getWidth( tempAmount .. " " .. tempName )/2), y = v.y - 20, timer = 0})
					
					found = false
					for j,k in ipairs(inventory) do
						if k.name == tempName then
							found = true
							k.amount = k.amount + tempAmount
						end
					end
					if not found then
						table.insert(inventory, {name = tempName, amount = tempAmount})
					end
					table.remove(objects, i)
				elseif player.inventoryMax == player.inventory and timer > 0.5 then
					timer = 0
					table.insert(msgs, {msg = "Inventory Full!", x = player.x - (font1:getWidth( "Inventory Full!" )/2), y = player.y - 20, timer = 0})
				end
			elseif v.type == 4 and func.checkDistColl(player,v) then
				rng = love.math.random(159)
				if player.inventoryMax == player.inventory then
					rng = 999
				end
					
				if rng == 999 and v.timer > 0.4 then
					timer = 0
					table.insert(msgs, {msg = "Inventory Full!", x = player.x - (font1:getWidth( "Inventory Full!" )/2), y = player.y - 20, timer = 0})
					tempName = "full"
				elseif rng == 999 then
					tempName = "full"
				elseif rng == 1 then
					tempName = "Uranium"
					table.insert(msgs, {msg = "1 " .. tempName, x = v.x - (font1:getWidth( "1 " .. tempName )/2), y = v.y- 26, timer = 0})
					for d,f in ipairs(resources) do
						if f.name == tempName then
							table.insert(msgs, {msg = f.rarity * 10 .. " XP", x = v.x - (font1:getWidth( f.rarity * 10 .. " XP" )/2), y = v.y- 14, timer = 0})
						end
					end
				elseif rng < 4 then
					tempName = "Diamond"
					table.insert(msgs, {msg = "1 " .. tempName, x = v.x - (font1:getWidth( "1 " .. tempName )/2), y = v.y- 26, timer = 0})
					for d,f in ipairs(resources) do
						if f.name == tempName then
							table.insert(msgs, {msg = f.rarity * 10 .. " XP", x = v.x - (font1:getWidth( f.rarity * 10 .. " XP" )/2), y = v.y- 14, timer = 0})
						end
					end
				elseif rng < 10 then
					tempName = "Gold"
					table.insert(msgs, {msg = "1 " .. tempName, x = v.x - (font1:getWidth( "1 " .. tempName )/2), y = v.y- 26, timer = 0})
					for d,f in ipairs(resources) do
						if f.name == tempName then
							table.insert(msgs, {msg = f.rarity * 10 .. " XP", x = v.x - (font1:getWidth( f.rarity * 10 .. " XP" )/2), y = v.y- 14, timer = 0})
						end
					end
				elseif rng < 20 then
					tempName = "Silver"
					table.insert(msgs, {msg = "1 " .. tempName, x = v.x - (font1:getWidth( "1 " .. tempName )/2), y = v.y- 26, timer = 0})
					for d,f in ipairs(resources) do
						if f.name == tempName then
							table.insert(msgs, {msg = f.rarity * 10 .. " XP", x = v.x - (font1:getWidth( f.rarity * 10 .. " XP" )/2), y = v.y- 14, timer = 0})
						end
					end
				elseif rng < 40 then
					tempName = "Aluminium"
					table.insert(msgs, {msg = "1 " .. tempName, x = v.x - (font1:getWidth( "1 " .. tempName )/2), y = v.y - 26, timer = 0})
					for d,f in ipairs(resources) do
						if f.name == tempName then
							table.insert(msgs, {msg = f.rarity * 10 .. " XP", x = v.x - (font1:getWidth( f.rarity * 10 .. " XP" )/2), y = v.y- 14, timer = 0})
						end
					end
				elseif rng < 80 then
					tempName = "Copper"
					table.insert(msgs, {msg = "1 " .. tempName, x = v.x - (font1:getWidth( "1 " .. tempName )/2), y = v.y - 26, timer = 0})
					for d,f in ipairs(resources) do
						if f.name == tempName then
							table.insert(msgs, {msg = f.rarity * 10 .. " XP", x = v.x - (font1:getWidth( f.rarity * 10 .. " XP" )/2), y = v.y- 14, timer = 0})
						end
					end
				elseif rng < 160 then
					tempName = "Iron"
					table.insert(msgs, {msg = "1 " .. tempName, x = v.x - (font1:getWidth( "1 " .. tempName )/2), y = v.y - 26, timer = 0})
					for d,f in ipairs(resources) do
						if f.name == tempName then
							table.insert(msgs, {msg = f.rarity * 10 .. " XP", x = v.x - (font1:getWidth( f.rarity * 10 .. " XP" )/2), y = v.y- 14, timer = 0})
						end
					end
				else
					tempName = "null"
				end
		
				if tempName ~= "null" and tempName ~= "full" and player.inventoryMax > player.inventory then
					player.inventory = player.inventory + 1
					for d,f in ipairs(resources) do
						if f.name == tempName then
							player.xp = player.xp + (f.rarity * 10)
						end
					end
					
					if player.xp >= player.xpNext then
						player.xp = player.xp - player.xpNext
						player.xpNext = player.xpNext * 2
						player.level = player.level + 1
					end
	
					found = false
					for j,k in ipairs(inventory) do
						if k.name == tempName then
							found = true
							k.amount = k.amount + 1
						end
					end
					if not found then
						table.insert(inventory, {name = tempName, amount = 1})
					end
				end
				if tempName ~= "full" then
					table.remove(objects, i)
				end
			elseif v.type == 5 and func.checkDistColl(player,v) then
				if player.inventoryMax - player.inventory >= v.amount then
					found = false
					table.insert(msgs, {msg = v.amount .. " " .. v.name, x = v.x - (font1:getWidth( v.amount .. " " .. v.name )/2), y = v.y - 26, timer = 0})
					player.inventory = player.inventory + v.amount
					for j,k in ipairs(inventory) do
						if k.name == v.name then
							found = true
							k.amount = k.amount + v.amount
						end
					end
					if not found then
						table.insert(inventory, {name = v.name, amount = v.amount})
					end
					table.remove(objects, i)
				elseif player.inventoryMax >= player.inventory + v.amount and timer > 0.5 then
					timer = 0
					table.insert(msgs, {msg = "Inventory Full!", x = player.x - (font1:getWidth( "Inventory Full!" )/2), y = player.y - 20, timer = 0})
				end
			elseif v.type == 6 and func.checkDistColl(player,v) then
				if player.inventoryMax > player.inventory then
					tempAmount = love.math.random(1 + math.floor(v.level/2))
					if tempAmount + player.inventory > player.inventoryMax then
						tempAmount = player.inventoryMax - player.inventory
					end
					player.inventory = player.inventory + tempAmount
					if player.level < v.level then
						p = 6 - (v.level - player.level)
					else
						p = 7
					end
					foundRes = false
					while p <= #resources do
						if player.level < v.level and love.math.random(resources[p]["rarity"]) == 1 + math.floor((v.level - player.level)/2) then
							tempName = resources[p]["name"]
							p = #resources + 1
							foundRes = true
						elseif player.level >= v.level and love.math.random(resources[p]["rarity"]) == 1  then
							tempName = resources[p]["name"]
							p = #resources + 1
							foundRes = true
						end
						if p == #resources and not foundRes then
							if player.level < v.level then
								p = 5 - (v.level - player.level)
							else
								p = 6
							end
						end
						p = p + 1
					end
					table.insert(msgs, {msg = tempAmount .. " " .. tempName, x = v.x - (font1:getWidth( tempAmount .. " " .. tempName )/2), y = v.y - 20, timer = 0})
					
					found = false
					for j,k in ipairs(inventory) do
						if k.name == tempName then
							found = true
							k.amount = k.amount + tempAmount
						end
					end
					if not found then
						table.insert(inventory, {name = tempName, amount = tempAmount})
					end
					table.remove(objects, i)
				elseif player.inventoryMax == player.inventory and timer > 0.5 then
					timer = 0
					table.insert(msgs, {msg = "Inventory Full!", x = player.x - (font1:getWidth( "Inventory Full!" )/2), y = player.y - 20, timer = 0})
				end
			end
			
			if v.type == 5 or v.type == 4 or v.type == 3 or type == 6 then
				v.x = v.x + (4 * dt)
				v.y = v.y + (4 * dt)
			end
			if v.type == 1 then
				v.x = v.x - (4 * dt)
				v.y = v.y + (6 * dt)
			end
			
			if v.type == 2 then
				v.timer = v.timer + dt
				
				if status == 1 then
					v.destX = planets[v.planet]["x"]
					v.destY = planets[v.planet]["y"]
				elseif v.status == 2 then
					if math.random(5000) == 1 then
						v.status = 3
						v.hostile = true
						if love.math.random(2) == 1 then
							v.destX = v.x + love.math.random(-400,-100)
							v.destX = v.x + love.math.random(-400,-100)
						else
							v.destX = v.x + love.math.random(100,400)
							v.destX = v.x + love.math.random(100,400)
						end
					else
						v.destX = player.x
						v.destY = player.y
						
						if v.timer > 0.4 + (love.math.random(10)/30) then
							v.timer = 0
							for i = 1, v.guns do
								if v.guns == 1 then
									gunsOffset = 0
								elseif v.guns == 2 then
									if i == 1 then
										gunsOffset = 10
									elseif i == 2 then
										gunsOffset = -10
									end
								elseif v.guns == 3 then
									if i == 1 then
										gunsOffset = 10
									elseif i == 2 then
										gunsOffset = -10
									elseif i == 3 then
										gunsOffset = 0
									end
								end
								v.timer = 0 - (love.math.random(10)/30)
								angle = math.atan2((love.mouse.getX() - v.y), (love.mouse.getY() - v.x))
								startX = v.x + (gunsOffset * math.sin(math.pi-(func.findRotation(v.x,v.y,player.x,player.y) + math.pi*1)))
								startY = v.y + (gunsOffset * math.cos(math.pi-(func.findRotation(v.x,v.y,player.x,player.y) + math.pi*1)))
								local rng = love.math.random(-5,5)
								local stopX = player.x + rng
								local stopY = player.y + rng
								angle = math.atan2((stopY - startY), (stopX - startX))
						 
						 
								local bulletDx = (420 + (v.level * 10)) * math.cos(angle)
								local bulletDy = (420 + (v.level * 10)) * math.sin(angle)
								
								local Dmg = v.level - player.defence
								if Dmg < 1 then
									Dmg = 1
								end
							
								table.insert(bullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy, size = 2, id = 2, dmg = Dmg, color = v.shotColor})
							end
						end
					end
				end
				
				local startX = v.x
				local startY = v.y
				local stopX = v.destX
				local stopY = v.destY
        
				local rot = math.atan2((stopY - startY), (stopX - startX))
        
				v.dx = (100 + (v.level * 10)) * math.cos(rot)
				v.dy = (100 + (v.level * 10)) * math.sin(rot)
				
				for j,k in ipairs(objects) do
					if func.checkDistColl(v, k) and i ~= j and v.status ~= 3 and k.status ~= 3 then
						if v.x > k.x then
							if v.status == 2 then
								v.hostile = true
							end
							if k.status == 2 then
								k.hostile = true
							end
							v.lastDestX = v.destX
							v.lastDestY = v.destY
							k.lastDestX = k.destX
							k.lastDestY = k.destY
							v.status = 3
							v.destX = v.x + 10
							k.destX = k.x - 10
							if v.y > k.y then
								v.destY = v.y + 10
								k.destY = k.y - 10
							else
								v.destY = v.y - 10
								k.destY = k.y + 10
							end
							k.status = 3
							k.destX = k.x - 10
							k.destY = k.y
						elseif v.x < k.x then
							if v.status == 2 then
								v.hostile = true
							end
							if k.status == 2 then
								k.hostile = true
							end
							v.lastDestX = v.destX
							v.lastDestY = v.destY
							k.lastDestX = k.destX
							k.lastDestY = k.destY
							v.status = 3
							v.destX = v.x - 10
							k.destX = k.x + 10
							if v.y > k.y then
								v.destY = v.y + 10
								k.destY = k.y - 10
							else
								v.destY = v.y - 10
								k.destY = k.y + 10
							end
							k.status = 3
						end
					end
				end
				
				if func.checkDistColl(v, player) and v.status ~= 3 then
					if v.x > player.x then
						if v.status == 2 then
							v.hostile = true
						end
						v.status = 3
						v.lastDestX = v.destX
						v.lastDestY = v.destY
						v.destX = v.x + 30
						if v.y > player.y then
							v.destY = v.y + 10
						else
							v.destY = v.y - 10
						end
					elseif v.x < player.x then
						if v.status == 2 then
							v.hostile = true
						end
						v.status = 3
						v.lastDestX = v.destX
						v.lastDestY = v.destY
						v.destX = v.x - 30
						v.destY = v.y
					end
				end
				
				v.x = v.x + (v.dx * dt)
				v.y = v.y + (v.dy * dt)
				if v.status == 3 then
					v.destX = v.destX - (v.dx * dt)
					v.destY = v.destY - (v.dy * dt)
				end
				
				v.angle = func.findRotation(v.x, v.y, v.destX, v.destY) +  math.pi/1
				
				if math.floor(v.x) == math.floor(v.destX) and math.floor(v.y) == math.floor(v.destY) and v.status == 1 then
					v.destX = planets[love.math.random(#planets)]["x"]
					v.destY = planets[love.math.random(#planets)]["y"]
				elseif math.floor(v.x) == math.floor(v.destX) and math.floor(v.y) == math.floor(v.destY) and v.status == 3 then
					if v.hostile then
						v.status = 2
						v.hostile = false
					else
						v.status = 1
						v.destX = v.lastDestX
						v.destY = v.lastDestY
					end
				end
			end
			
			if v.x > love.window.getWidth() + 4000 or v.x < -4000 or v.y > love.window.getHeight() + 4000 or v.y < -4000 then
				if v.type == 1 then
					func.createAsteroid()
				end
				table.remove(objects, i)
			end
			
		end
		
		rad = func.findRotation(player.x,player.y,love.mouse.getX(),love.mouse.getY()) +  math.pi*1
	
		if Y > -universSize and (love.keyboard.isDown("up") or love.keyboard.isDown("w")) and not map and not openWindow and not inven then
			Y = Y - (player.speed * dt)
			if Y < -universSize then
				Y = -universSize
			end
				
			waypointY = waypointY + (player.speed * dt)
			up = true
		else
			up = false
		end
		
		if Y < universSize and (love.keyboard.isDown("down") or love.keyboard.isDown("s")) and not map and not openWindow and not inven then
			Y = Y + (player.speed * dt)
			if Y > universSize then
				Y = universSize
			end
			waypointY = waypointY - (player.speed * dt)
			down = true
		else
			down = false
		end
		
		if X > -universSize and (love.keyboard.isDown("left") or love.keyboard.isDown("a")) and not map and not openWindow and not inven then
			X = X - (player.speed * dt)
			if X < -universSize then
				X = -universSize
			end
			waypointX = waypointX + (player.speed * dt)
			left = true
		else
			left = false
		end
		
		if X < universSize and (love.keyboard.isDown("right") or love.keyboard.isDown("d")) and not map and not openWindow and not inven then
			X = X + (player.speed * dt)
			if X > universSize then
				X = universSize
			end
			waypointX = waypointX - (player.speed * dt)
			right = true
		else
			right = false
		end
	
		if up or down or left or right then
			for i,v in ipairs(msgs) do
		
				if up then
					v.y = v.y + (player.speed * dt)
				end
		
				if down then
					v.y = v.y - (player.speed * dt)
				end
		
				if left then
					v.x = v.x + (player.speed * dt)
				end
		
				if right then
					v.x = v.x - (player.speed * dt)
				end
			end
			for i,v in ipairs(planets) do
		
				if up then
				v.y = v.y + (player.speed * dt)
				end
		
				if down then
				v.y = v.y - (player.speed * dt)
				end
		
				if left then
					v.x = v.x + (player.speed * dt)
				end
		
				if right then
					v.x = v.x - (player.speed * dt)
				end
			end
			
			for i,v in ipairs(bullets) do
		
				if up then
					v.y = v.y + (player.speed * dt)
				end
		
				if down then
					v.y = v.y - (player.speed * dt)
				end
		
				if left then
					v.x = v.x + (player.speed * dt)
				end
		
				if right then
					v.x = v.x - (player.speed * dt)
				end
			end
			
			for i,v in ipairs(objects) do
		
				if up then
					v.y = v.y + (player.speed * dt)
				end
		
				if down then
					v.y = v.y - (player.speed * dt)
				end
		
				if left then
					v.x = v.x + (player.speed * dt)
				end
		
				if right then
					v.x = v.x - (player.speed * dt)
				end
			end
			
			for i,v in ipairs(background) do
				
				if up then
					for u = 1,4 do
						if u == v.layer then
							v.y = v.y + ((player.speed/u) * dt)
						end
					end
					
					if v.y > love.window.getHeight() + 100 then
						if v.extra and v.y > love.window.getHeight() + 4000 then
							table.remove(background, i)
						elseif not v.extra then
							v.y = love.math.random(-100,-1)
							v.x = love.math.random(love.window.getWidth())
						end
					end
				end
		
				if down then
					for u = 1,4 do
						if u == v.layer then
							v.y = v.y - ((player.speed/u) * dt)
						end
					end
					if v.y < -100 then
						if v.extra and v.y < -4000  then
							table.remove(background, i)
						elseif not v.extra then
							v.y = love.window.getHeight() + love.math.random(100)
							v.x = love.math.random(love.window.getWidth())
						end
					end
				end
		
				if left then
					for u = 1,4 do
						if u == v.layer then
							v.x = v.x + ((player.speed/u) * dt)
						end
					end
					if v.x > love.window.getWidth() + 100 then
						if v.extra and v.x > love.window.getWidth() + 4000 then
							table.remove(background, i)
						elseif not v.extra then
							v.y = love.math.random(love.window.getHeight())
							v.x = love.math.random(-100,-1)
						end
					end
				end
		
				if right then
					for u = 1,4 do
						if u == v.layer then
							v.x = v.x - ((player.speed/u) * dt)
						end
					end
					if v.x < -100 then
						if v.extra  and v.x < -4000 then
							table.remove(background, i)
						elseif not v.extra then
							v.y = love.math.random(love.window.getHeight())
							v.x = love.window.getWidth() + love.math.random(100)
						end
					end
				end
				
			end
		end
		
		extraBg = 0
		for i,v in ipairs(background) do
			if v.extra then
				v.y = v.y + (love.math.random(-2,2) * dt)
				v.x = v.x + (love.math.random(-2,2) * dt)
				extraBg = extraBg + 1
				if extraBg > 1000 then
					for j,k in ipairs(background) do
						if k.extra then
							table.remove(background, j)
							extraBg = extraBg - 1
							break
						end
					end
				end
			end
			for u = 1,4 do
				if u == v.layer then
					v.y = v.y + ((4/u) * dt)
					v.x = v.x + ((4/u) * dt)
					if v.x > love.window.getWidth() + 100 then
						if v.extra and v.x > love.window.getWidth() + 4000 then
							table.remove(background, i)
						elseif not v.extra then
							v.x = love.math.random(-100,-1)
						end
					end
					if v.y > love.window.getHeight() + 100 then
						if v.extra and v.x > love.window.getHeight() + 4000 then
							table.remove(background, i)
						elseif not v.extra then
							v.y = love.math.random(-100,-1)
						end
					end
				end
			end
		end
	end
	
	if love.keyboard.isDown("i") and timer > 0.4 and not paused then
		timer = 0
		map = false
		zoom = 1
		openWindow = false
		TB.destroyAll()
		if not inven then
			func.createInventory()
			inven = true
		else
			inven = false
			TB.destroyAll()
		end
	end
	
	if inven and love.mouse.isDown("r") then
		inven = false
		TB.destroyAll()
	end
	
	if love.keyboard.isDown("m") and timer > 0.4 and not paused then
		timer = 0
		inven = false
		openWindow = false
		TB.destroyAll()
		if not map then
			zoom = settings.tempZoom
			map = true
		else
			settings.tempZoom = zoom
			zoom = 1
			map = false
		end
	end
	
	if map and love.mouse.isDown("r") then
		map = false
		zoom = 1
	end
	
	if map and love.keyboard.isDown("pageup") and timer > 0.01 then
		timer = 0
		if zoom < 430 then 
			zoom = math.floor(zoom + (zoom/30))
			if zoom > 430 then
				zoom = 430
			end
		end
	elseif map and love.keyboard.isDown("pagedown") and timer > 0.02 then
		timer = 0
		if zoom > 31 then
			zoom = math.floor(zoom - (zoom/30))
			if zoom < 31 then
				zoom = 31
			end
		end
	end
		
	if love.keyboard.isDown("tab") and timer > 0.4 then
		timer = 0
		if not waypoint then
			waypoint = true
			if map then
				waypointX = (love.mouse.getX() - (love.window.getWidth()/2) + (player.x/zoom)) * zoom
				waypointY = (love.mouse.getY() - (love.window.getHeight()/2) + (player.y/zoom)) * zoom
			else
				waypointX = love.mouse.getX()
				waypointY = love.mouse.getY()
			end
		else
			waypoint = false
		end
	end

	waypointX2 = waypointX
	waypointY2 = waypointY

	if waypointX2 > love.window.getWidth() - 10 then
		waypointX2 = love.window.getWidth() - 10
	end

	if waypointX2 < 10 then
		waypointX2 = 10
	end

	if waypointY2 > love.window.getHeight() - 10 then
		waypointY2 = love.window.getHeight() - 10
	end

	if waypointY2 < 10 then
		waypointY2 = 10
	end
	
	if love.keyboard.isDown("escape") and timer > 0.4 and not newGame then
		if openWindow then 
			openWindow = false
			TB.destroyAll()
		end
		timer = 0
		
		if paused then	
			paused = false
			menu = false
			TB.destroyAll()
		else
			paused = true
			menu = true
			map = false
			zoom = 1
			inven = false
			TB.destroyAll()
			func.createMenu()
		end
	end
	
	if newGame and newGameSw  then
		TB.destroyAll()
		newGameSw = false
		func.createMenu()
	end
	
	if love.mouse.isDown("l") and not paused and not openWindow and not inven and player.afterBurnerBoost <= 0 and player.timer > 1 - (player.bulletSpeed/800) then
		--src1:play()
		local Col = {40 + love.math.random(50), 198, 50}
		for i = 1, player.guns do
			if player.guns == 1 then
				player.gunsOffset = 0
			elseif player.guns == 2 then
				if i == 1 then
					player.gunsOffset = 11
				elseif i == 2 then
					player.gunsOffset = -11
				end
			elseif player.guns == 3 then
				if i == 1 then
					player.gunsOffset = 11
				elseif i == 2 then
					player.gunsOffset = -11
				elseif i == 3 then
					player.gunsOffset = 0
				end
			end
			player.timer = 0
			startX = player.x + (player.gunsOffset * math.sin(math.pi-rad))
			startY = player.y + (player.gunsOffset * math.cos(math.pi-rad))
			local mouseX = love.mouse.getX()
			local mouseY = love.mouse.getY()
			angle = math.atan2((mouseY - startY), (mouseX - startX))
	 
	 
			local bulletDx = (player.bulletSpeed*1.2) * math.cos(angle)
			local bulletDy = (player.bulletSpeed*1.2) * math.sin(angle)
		
			table.insert(bullets, {x = startX, y = startY, dx = bulletDx, dy = bulletDy, size = 2, id = 1, color = Col})
		end
	end
	
	if loading > 20 then
		func.newSystem()
	end
	
	if loading > 10 and loading < 13 then
		func.loadGame()
	end

	if loading > 1 and loading < 3 then
		func.newGame()
	end
end