tablepersistence = require "tablepersistence"

if persistence.load("settings.lua") then
	settings = persistence.load("settings.lua")
else
	settings = {screenWidth = 800, screenHeight = 600}
end

function love.conf(t)
    t.modules.joystick = false   -- Enable the joystick module (boolean)
    t.modules.audio = true      -- Enable the audio module (boolean)
    t.modules.keyboard = true   -- Enable the keyboard module (boolean)
    t.modules.event = true      -- Enable the event module (boolean)
    t.modules.image = true      -- Enable the image module (boolean)
    t.modules.graphics = true   -- Enable the graphics module (boolean)
    t.modules.timer = true      -- Enable the timer module (boolean)
    t.modules.mouse = true      -- Enable the mouse module (boolean)
    t.modules.sound = true      -- Enable the sound module (boolean)
	t.modules.thread = true
    t.modules.physics = false    -- Enable the physics module (boolean)
    t.console = false           -- Attach a console (boolean, Windows only)
	t.identity = "game0.1"
    t.title = ""        -- The title of the window the game is in (string) 
    t.author = "Ludvig A. Verpe"        -- The author of the game (string)
    t.window.fullscreen = false -- Enable fullscreen (boolean)
    t.window.vsync = false       -- Enable vertical sync (boolean)
    t.window.fsaa = 0           -- The number of FSAA-buffers (number)
	t.window.width = settings.screenWidth       -- The window width (number)
    t.window.height = settings.screenHeight       -- The window height (number)
	t.window.minwidth = 800              -- Minimum window width if the window is resizable (number)
    t.window.minheight = 600             -- Minimum window height if the window is resizable (number)
	t.window.x = 30                   -- The x-coordinate of the window's position in the specified display (number)
    t.window.y = 30                   -- The y-coordinate of the window's position in the specified display (number)
	t.window.borderless = false  -- Remove all border visuals from the window (boolean)
	t.window.resizable = false         -- Let the window be user-resizable (boolean)
	t.window.icon = "data/ship.png"
end